﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;

namespace WpfApplication1.Data
{
    public class VM
    {
        public VM()
        {
            SaIds = new ObservableCollection<object>();
            ComboStrings = new ObservableCollection<SaId>();
            SelectedComboStrings = new ObservableCollection<object>();
            for (int i = 1; i <= 100; i++)
            {
                var saId = new SaId(i, "SA " + i);
                ComboStrings.Add(saId);
                SaIds.Add(saId);
            }
            SelectedComboStrings.Add(SaIds[1]);
            SelectedComboStrings.Add(SaIds[2]);
            SelectedComboStrings.Add(SaIds[4]);
            SelectedComboStrings.Add(SaIds[6]);

            Units = new ObservableCollection<ParameterUnit>();
            Units.Add(new ParameterUnit()
            {
                UnitId = "x0",
                Name = "meter",
                UnitSymbol = "m"
            });
            Units.Add(new ParameterUnit()
            {
                UnitId = "x1",
                Name = "degree",
                UnitSymbol = "°"
            });
            Units.Add(new ParameterUnit()
            {
                UnitId = "x2",
                Name = "gram",
                UnitSymbol = "g"
            });

            Parameters = new ObservableCollection<ParameterUi>();

            for (int i = 1; i <= 5000; i++)
            {
                var paraParent = new ParameterUi();
                Random rnd = new Random();
                bool isActive = true;
                ParameterUnit unit = null;
                ParameterUnit dbUnit = null;
                #region random

                //var valRnd = rnd.Next(0, 4);
                //switch (valRnd)
                //{
                //    case 1:
                //        unit = new ParameterUnit()
                //        {
                //            UnitId = "0",
                //            //Id = 0,
                //            Name = "meter",
                //            UnitSymbol = "m"
                //        };
                //        break;
                //    case 2:
                //        unit = new ParameterUnit()
                //        {
                //            UnitId = "1",
                //            //Id = 1,
                //            Name = "degree",
                //            UnitSymbol = "°"
                //        };
                //        break;
                //    case 3:
                //        unit = new ParameterUnit()
                //        {
                //            UnitId = "2",
                //            //Id = 2,
                //            Name = "gram",
                //            UnitSymbol = "g"
                //        };
                //        break;
                //    case 4:
                //        unit = new ParameterUnit()
                //        {
                //            UnitId = "dummy",
                //            //Id = -1,
                //            Name = "",
                //            UnitSymbol = ""
                //        };
                //        break;
                //}
                #endregion
                unit = Units[2];
                dbUnit = Units[2];

                paraParent.Self = new ParameterUiItem()
                {
                    Id = i,
                    Name = "Parameter " + i,
                    DbName = "Parameter " + i,
                    Unit = unit,
                    DbUnit = dbUnit,
                    IsActive = isActive
                };
                paraParent.Self.SelectedSaIds.Add(SaIds[2]);
                paraParent.Self.SelectedSaIds.Add(SaIds[3]);

                #region create childs
                //for (int j = 0; j < rnd.Next(0, 10); j++)
                //{
                //    var paraChild = new ParameterUiItem();
                //    paraChild.Id = rnd.Next(5000, 250000);
                //    paraChild.Name = "Parameter " + paraChild.Id;
                //    paraChild.Unit = Units.First(x => x.UnitId == paraParent.Self.Unit.UnitId);
                //    paraChild.IsActive = isActive;
                //    paraParent.Childs.Add(paraChild);
                //}
                #endregion

                Parameters.Add(paraParent);
            }
        }

        public ObservableCollection<object> SaIds { get; set; }

        public ObservableCollection<SaId> ComboStrings { get; set; }

        public ObservableCollection<object> SelectedComboStrings { get; set; }

        public ICommand DeleteParentParameter { get; private set; }

        public bool IsBusy { get; set; }

        public ObservableCollection<ParameterUi> Parameters { get; set; }

        public ObservableCollection<ParameterUnit> Units { get; set; }
    }
}
